# gsb2023

2023-01-25 ps 

Environnement et playbooks ansible pour le projet GSB 2023

## Quickstart
Prérequis : 
  * une machine Debian Bullseye
  * VirtualBox
  * fichier machines viruelles **ova** :
    * **debian-bullseye-gsb-2023a.ova**
    * **debian-buster-gsb-2023a.ova**



  * **s-adm** : routeur adm, DHCP + NAT, deploiement, proxy squid 
  * **s-infra** : DNS maitre, autoconfiguration navigateurs avec **wpad**
  * **r-int** : routage, DHCP 
  * **r-ext** : routage, NAT
  * **s-proxy** : squid
  * **s-itil** : serveur GLPI
  * **s-backup** : DNS esclave + sauvegarde s-win (SMB)
  * **s-mon** : supervision avec **Nagios4**, notifications et syslog
  * **s-fog** : deploiement postes de travail avec **FOG**
  * **s-win** : Windows Server 2019, AD, DNS, DHCP, partage fichiers
  * **s-nxc** : NextCloud avec **docker** 
  * **s-elk** : pile ELK dockerisée
  * **s-lb**  : Load Balancer **HaProxy** pour application Wordpress (DMZ)
  * **r-vp1** : Routeur VPN Wireguard coté siège
  * **r-vp2** : Routeur VPN Wireguard coté agence, DHCP
  * **s-agence** : Serveur agence
  * **s-lb**  : Load Balancer **HaProxy** pour application Wordpress 
  * **s-lb-web1** : Serveur Wordpress 1 Load Balancer
  * **s-lb-web2** : Serveur Wordpress 2 Load Balancer
  * **s-lb-db** : Serveur Mariadb pour Wordpress
  * **s-lb-nfs** : Serveur NFS pour application Wordpress


## Les playbooks


## Installation

On utilisera l'image de machine virtuelle suivante : 
  * **debian-bullseye-2023a.ova** (2023-01-06)
    * Debian Bullseye 11.6 - 2 cartes - 1 Go - stockage 20 Go


### Machine s-adm
  * créer la machine virtuelle **s-adm** en important l'image ova décrite plus haut
  * renommer la machine puis redémarrer
  * taper :
```shell
    mkdir -p tools/ansible ; cd tools/ansible
    git clone https://gitea.lyc-lecastel.fr/gadmin/gsb2023.git
    cd gsb2023/pre
    bash inst-depl
    cd /var/www/html/gsbstore
    bash getall
    cd /root/tools/ansible/gsb023/pre
    bash gsbboot
    cd .. ; bash pull-config
```
  - redémarrer
  
### Pour chaque machine

  - importer la machine à partir du fichier **.ova**
  - définir les cartes réseau en accord avec le plan d'adressage et le schéma
  - donner le nom adapté (avec sed -i …)
  - redémarrer
  - mettre à jour les paquets : apt update && apt upgrade
  - cloner le dépot : 
```shell
mkdir -p tools/ansible ; cd tools/ansible
git clone https://gitea.lyc-lecastel.fr/gadmin/gsb2023.git
cd gsb2023/pre
export DEPL=192.168.99.99
bash gsbboot
cd ../..
bash pull-config
```
  - **Remarque** : une machine doit avoir été redémarrée pour prendre en charge la nouvelle configuration


